commit 2b473c6dbd8735a59409c18b5aac72cefe355451
Author: freddy77 <freddy77>
Date:   Mon May 11 07:53:26 2009 +0000

    fix row buffering checks

diff --git a/ChangeLog b/ChangeLog
index eeda3fe..39db555 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Mon May 11 09:52:26 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/buffering.h: fix a test
+	* src/dblib/unittests/t0013.c src/dblib/unittests/t0013.sql:
+	- remove table if exixts
+
 Mon May 11 09:24:40 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/ct.c: remove warnings and duplicate logs
 
@@ -1531,4 +1536,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2783 2009/05/11 07:25:24 freddy77 Exp $
+$Id: ChangeLog,v 1.2784 2009/05/11 07:53:26 freddy77 Exp $
diff --git a/src/dblib/buffering.h b/src/dblib/buffering.h
index 4c9bf7b..d07c32b 100644
--- a/src/dblib/buffering.h
+++ b/src/dblib/buffering.h
@@ -21,8 +21,8 @@ static void buffer_check(const DBPROC_ROWBUF *buf)
 	/* no buffering */
 	if (buf->capacity == 0 || buf->capacity == 1) {
 		assert(buf->head == 0);
-		assert(buf->tail == 0);
-		assert(buf->rows == NULL);
+		assert(buf->tail == 0 || buf->tail == 1);
+		assert(buf->capacity == 1 || buf->rows == NULL);
 		return;
 	}
 
@@ -432,12 +432,14 @@ buffer_set_capacity(DBPROCESS *dbproc, int nrows)
 
 	if (0 == nrows) {
 		buf->capacity = 1;
+		BUFFER_CHECK(buf);
 		return;
 	}
 
 	assert(0 < nrows);
 
 	buf->capacity = nrows;
+	BUFFER_CHECK(buf);
 }
 
 /*
diff --git a/src/dblib/unittests/t0013.c b/src/dblib/unittests/t0013.c
index 6f88015..a939907 100644
--- a/src/dblib/unittests/t0013.c
+++ b/src/dblib/unittests/t0013.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0013.c,v 1.29 2009/02/27 15:52:48 freddy77 Exp $";
+static char software_version[] = "$Id: t0013.c,v 1.30 2009/05/11 07:53:26 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define BLOB_BLOCK_SIZE 4096
@@ -106,6 +106,8 @@ main(int argc, char **argv)
 	fread((void *) blob, isiz, 1, fp);
 	fclose(fp);
 
+	drop_table();
+
 	sql_cmd(dbproc);
 	dbsqlexec(dbproc);
 	while (dbresults(dbproc) != NO_MORE_RESULTS) {
diff --git a/src/dblib/unittests/t0013.sql b/src/dblib/unittests/t0013.sql
index 9f976c2..4cbebf5 100644
--- a/src/dblib/unittests/t0013.sql
+++ b/src/dblib/unittests/t0013.sql
@@ -1,3 +1,5 @@
+if object_id('freetds_dblib_t0013') is not null drop table freetds_dblib_t0013
+go
 create table freetds_dblib_t0013 (i int not null, PigTure image not null)
 go
 insert into freetds_dblib_t0013 values (1, '')

